//neopixels.h

#ifndef HEADER_NEO_FUNC
  #define HEADER_NEO_FUNC

    #include "Arduino.h"
    #include "tinyNeoPixel_Static.h"

    typedef struct {
      int x;
      int y;
      int z;
    } HEXAGON;

    typedef struct {
        byte pixels[8*6 * 3]; //Colors
        byte id[8*6]; //IDs
        byte num_elements; //Number that is actually filled
    } COLORS;

    extern COLORS original_colors;

    ////////// Light functions //////////
    void colorField( bool full_field );

    void hexagonRainbow(HEXAGON center, bool fade_out);

    void initialLightBurst( HEXAGON center );
    
    void lightBurst( HEXAGON center );

    /////// Hexagon grid functions ///////

    int hexToIndex( int x, int y, int z );

    // int cubeDistance( byte a, byte b );

    // void cubeRing( HEXAGON center, int radius, int grid_locations[]);
    void cubeRing(HEXAGON center, int radius, COLORS *original_colors);
    //void setCubeRing( HEXAGON center, int radius, byte red, byte green, byte blue );

    HEXAGON cubeAdd( HEXAGON a, HEXAGON b );

    HEXAGON cubeScale( HEXAGON a, int f );

    HEXAGON cubeNeighbor( HEXAGON a, byte direction );

#endif